#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef double CircleT;

typedef double SquareT;

typedef struct
{
  double height, width;
} RectangleT;

typedef struct
{
  double side1, side2, side3;
} TriangleT;

typedef struct
{
  char type;
  union
  {
    CircleT c;
    SquareT s;
    RectangleT r;
    TriangleT t;
  }
  edges;
} FigureT;


int main()
{
    FigureT f;

    do
    {
      printf("Figure type (c[ircle], s[quare], r[ectangle], t[riangle]): ");
      scanf("%c", &f.type);
      switch (f.type)
      {
        case 'c':
          printf("radius=");
          scanf("%lf", &f.edges.c);
          printf("Circle with radius %f has an area of %f\n",
            f.edges.c, f.edges.c * f.edges.c * M_PI);
          break;

        case 's':
          printf("side=");
          scanf("%lf", &f.edges.s);
          printf("Square with side %f has an area of %f\n",
            f.edges.s, f.edges.s * f.edges.s);

          break;

        case 'r':
          printf("width height=");
          scanf("%lf%lf", &f.edges.r.width, &f.edges.r.height);
          printf("Rectangle with height %f and width %f has an area of %f\n",
            f.edges.r.height, f.edges.r.width, f.edges.r.height * f.edges.r.width);
          break;

        case 't':
          printf("side1 side2 side3=");
          scanf("%lf%lf%lf", &f.edges.t.side1, &f.edges.t.side2, &f.edges.t.side3);
          double s = (f.edges.t.side1 + f.edges.t.side2 + f.edges.t.side3) / 2.0;
          printf("Triangle with edges %f %f %f has an area of %f\n",
            f.edges.t.side1, f.edges.t.side2, f.edges.t.side3,
            sqrt(s * (s-f.edges.t.side1) * (s-f.edges.t.side2) * (s-f.edges.t.side3)));
          break;

        default:
          if (f.type != 'x')
            fprintf(stderr, "Invalid figure type %c\n", f.type);
          break;
      }
      scanf("%*c");

    } while (f.type != 'x');

    return 0;
}
